Name: xsd
Version: 4.1.0
Release:    1%{?dist}
Summary: W3C XML schema to C++ data binding compiler
License: GPLv2 with exceptions and ASL 2.0  
URL: https://www.codesynthesis.com/products/xsd/
Source0: https://codesynthesis.com/~boris/tmp/xsd/%{version}.a11/xsd-%{version}.a11+dep.tar.bz2

Patch0: %{name}-%{version}-xsdcxx-rename.patch

Patch1: %{name}-xerces_3-2.patch

BuildRequires: make
BuildRequires: m4, xerces-c-devel, libcutl-devel, gcc-c++

BuildRequires: boost-devel

%description
CodeSynthesis XSD is an open-source, cross-platform W3C XML Schema to
C++ data binding compiler. Provided with an XML instance specification
(XML Schema), it generates C++ classes that represent the given
vocabulary as well as parsing and serialization code.
You can then access the data stored in XML using types and functions
that semantically correspond to your application domain rather than
dealing with intricacies of reading and writing XML.

%package   doc
BuildArch: noarch
BuildRequires: ghostscript
Summary:   API documentation files for %{name}

%description    doc
This package contains API documentation for %{name}.

%prep
%autosetup -p0 -n xsd-%{version}.a11+dep

rm -rf libcutl

%build
%make_build verbose=1 CXX=g++ CC=gcc CXXFLAGS="$RPM_OPT_FLAGS -std=c++14 -fPIC -pie -Wl,-z,now" LDFLAGS="%{__global_ldflags} -fPIC -pie -Wl,-z,now" BOOST_LINK_SYSTEM=y EXTERNAL_LIBCUTL=y

%install
rm -rf apidocdir

%make_install LDFLAGS="%{__global_ldflags}" install_prefix=%{buildroot}%{_prefix} \
 install_bin_dir=%{buildroot}%{_bindir} install_man_dir=%{buildroot}%{_mandir} EXTERNAL_LIBCUTL=y BOOST_LINK_SYSTEM=y

mkdir -p apidocdir
mv %{buildroot}%{_datadir}/doc/xsd/*.{xhtml,css} apidocdir/
mv %{buildroot}%{_datadir}/doc/xsd/cxx/ apidocdir/
mv %{buildroot}%{_datadir}/doc/xsd/ docdir/

for file in docdir/NEWS; do
    mv $file timestamp
    iconv -f ISO-8859-1 -t UTF-8 -o $file timestamp
    touch -r timestamp $file
done

mv %{buildroot}%{_bindir}/xsd %{buildroot}%{_bindir}/xsdcxx
mv %{buildroot}%{_mandir}/man1/xsd.1 %{buildroot}%{_mandir}/man1/xsdcxx.1

rm -rf %{buildroot}%{_datadir}/doc/libxsd

rm -rf %{buildroot}%{_includedir}/xsd/cxx/compilers

find apidocdir -name "*.ps" | xargs rm -f
find apidocdir -name "*.doxygen" \
            -o -name "makefile" \
            -o -name "*.html2ps" | xargs rm -f

%check
make -j 1 test EXTERNAL_LIBCUTL=y BOOST_LINK_SYSTEM=y

%files
%doc docdir/README docdir/NEWS docdir/FLOSSE
%license docdir/GPLv2 docdir/LICENSE
%{_bindir}/xsdcxx
%{_mandir}/man1/xsdcxx.1*
%{_includedir}/xsd/

%files doc
%doc docdir/README docdir/NEWS docdir/FLOSSE
%license docdir/GPLv2 docdir/LICENSE
%doc apidocdir/*

%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.1.0-1
- initial build
